#ifndef GRID_SERVER_GACL_PLUGIN_H
#define GRID_SERVER_GACL_PLUGIN_H

#include "util++.h"
#include <iostream>
#include "../fileroot.h"
#include "../userspec.h"

#define ACL_MAX_SIZE 65535
/* this class is used to communicate with network layer - 
   must be derived from FilePlugin */
class GACLPlugin: public FilePlugin {
 private:
  GACLacl *acl;
  string subject;  /* DN of client , TODO - remove */
  AuthUser* user;
  string basepath; /* path to root of served data in filesystem */
  int data_file;
  char acl_buf[ACL_MAX_SIZE+1];
  int acl_length;
  typedef enum {
    file_access_none,
    file_access_read,
    file_access_create,
    file_access_overwrite,
    file_access_read_acl,
    file_access_write_acl
  } file_access_mode_t;
  file_access_mode_t file_mode;
  string file_name;
  GACLnamevalue *subst;
  bool fill_object_info(DirEntry &dent,string dirname,DirEntry::object_info_level mode);
 public:
  GACLPlugin(istream &cfile,userspec_t &user);
  ~GACLPlugin(void);
  virtual int open(const char* name,open_modes mode,unsigned long long int size = 0);
  virtual int close(bool eof = true);
  virtual int read(unsigned char *buf,unsigned long long int offset,unsigned long long int *size);
  virtual int write(unsigned char *buf,unsigned long long int offset,unsigned long long int size);
  virtual int readdir(const char* name,list<DirEntry> &dir_list,DirEntry::object_info_level mode);
  virtual int checkdir(string &dirname);
  virtual int checkfile(string &name,DirEntry &file,DirEntry::object_info_level mode);
  virtual int makedir(string &dirname);
  virtual int removefile(string &name);
  virtual int removedir(string &dirname);
};

#endif
