#include "../../std.h"

#include "util++.h"

#include "../../misc/log_time.h"

GACLperm GACLtestFileAclForVOMS(const char *filename,const AuthUser& user,bool gacl_itself) {
/*
#ifdef HAVE_VOMS
GACLperm GACLtestFileAclForVOMS(const char *filename,const char* subject,const vector<struct voms> &voms_data,bool gacl_itself) {
#else
GACLperm GACLtestFileAclForVOMS(const char *filename,const char* subject,bool gacl_itself) {
#endif
*/
  const char* name;
  int path_l;
  char* gname;
  GACLacl* acl = NULL;
  struct stat st;
  GACLperm perm;
  const char* gacl_name = ".gacl-";

  if(user.DN()[0] == 0) return GACL_PERM_NONE;
  if(!gacl_itself) {
    gname=GACLmakeName(filename);
    if(gname == NULL) return GACL_PERM_NONE;
    if(stat(gname,&st) == 0) {
      if(!S_ISREG(st.st_mode)) {
        olog<<"GACL file "<<gname<<" is not an ordinary file"<<endl;
        free(gname); return GACL_PERM_NONE;
      };
      acl=GACLloadAcl(gname);
    } else {
      acl=GACLloadAclForFile((char*)filename); // take inherited
    };
    free(gname);
  } else {
    if(stat(filename,&st) == 0) {
      if(!S_ISREG(st.st_mode)) {
        olog<<"GACL file "<<filename<<" is not an ordinary file"<<endl;
        return GACL_PERM_NONE;
      };
      acl=GACLloadAcl((char*)filename);
    } else {
      acl=GACLloadAclForFile((char*)filename); // take inherited 
    };
  };
  if(acl == NULL) {
    olog<<"GACL description for file "<<filename<<" could not be loaded"<<endl;
    return GACL_PERM_NONE;
  };
  perm=AuthUserGACLTest(acl,(AuthUser&)user);
  GACLfreeAcl(acl);
  return perm;
err_exit:
  if(acl) GACLfreeAcl(acl);
  return GACL_PERM_NONE;
}

