#ifndef GRID_SERVER_JOB_PLUGIN_H
#define GRID_SERVER_JOB_PLUGIN_H

#include <iostream>
#include "../fileroot.h"
#include "../userspec.h"
#include "../../run/run.h"
#include "../../auth/gacl_auth.h"

class DirectFilePlugin;
class JobUser;
class ContinuationPlugins;

/* this class is used to communicate with network layer - 
   must be derived from FilePlugin */
class JobPlugin: public FilePlugin {
 private:
  bool make_job_id(const string &);
  bool make_job_id(void);
  bool delete_job_id(void);
  int is_allowed(const char* name,bool locked = false,bool* spec_dir = NULL,string* id = NULL,char const ** logname = NULL,string* log = NULL);
  JobUser *user;
  AuthUser* user_a;
  string subject;
  unsigned short int port;
  int host[4];
  string proxy_fname; /* name of proxy file passed by client */
  string job_id;
  char job_rsl[131072];
  bool initialized;
  bool rsl_opened;
  DirectFilePlugin* direct_fs;
  bool readonly;
  ContinuationPlugins* cont_plugins;
  RunPlugin* cred_plugin;
  static RunParallel run;
 public:
  JobPlugin(istream &cfile,userspec_t &user);
  ~JobPlugin(void);
  virtual int open(const char* name,open_modes mode,unsigned long long int size = 0);
  virtual int close(bool eof);
  virtual int read(unsigned char *buf,unsigned long long int offset,unsigned long long int *size);
  virtual int write(unsigned char *buf,unsigned long long int offset,unsigned long long int size);
  virtual int readdir(const char* name,list<DirEntry> &dir_list,DirEntry::object_info_level mode);
  virtual int checkdir(string &dirname);
  virtual int checkfile(string &name,DirEntry &file,DirEntry::object_info_level mode);
  virtual int makedir(string &dirname);
  virtual int removefile(string &name);
  virtual int removedir(string &dirname);
};

#endif
