#ifndef GRID_SERVER_USERSPEC_H
#define GRID_SERVER_USERSPEC_H

#include <string>
#include <list>
#include <globus_ftp_control.h>

#include "../auth/auth.h"

class userspec_t {
  friend int fill_user_spec(userspec_t *spec,globus_ftp_control_auth_info_t *auth,gss_cred_id_t delegated_cred,globus_ftp_control_handle_t *handle);
  friend string subst_user_spec(string &in,userspec_t *spec);
 private:
  char* name;
  int   uid;
  char* group;
  int   gid;
  char* home;
  int   host[4];
  short unsigned int port;
 public:
  bool  gridmap;
  AuthUser user;
  void free(void);
  userspec_t(void);
  ~userspec_t(void);
  bool unix_user(const char* name,const char* group);
  int get_uid(void) { return uid; };
  int get_gid(void) { return gid; };
  const char* get_uname(void) { return name; };
  const char* get_gname(void) { return group; };
  short unsigned int get_port(void) { return port; };
  int* get_host(void) { return host; };
};

int fill_user_spec(userspec_t *spec,globus_ftp_control_auth_info_t *auth,gss_cred_id_t delegated_cred,globus_ftp_control_handle_t *handle);
string subst_user_spec(string &in,userspec_t *spec);
bool check_gridmap(const char* dn,char** user,const char* mapfile = NULL);

#endif
