/*
  
   Copyright 2004 Jonas Bardino

   This file is part of NorduGRID GridSSH.

    NorduGRID GridSSH is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    NorduGRID GridSSH is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NorduGRID GridSSH; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __GSFTP_H__
#define __GSFTP_H__
#define GRIDSFTP_VERSION "0.1.6" 

/* Client defaults */
#define MAX_PORT 65536

#define PORT_FLAG "-oPort="
#define USER_FLAG "-oUser="
#define KEY_FLAG "-oIdentityFile="

#define INTERNAL_SFTP_ARGS 3

/* This is the exit code if ssh itself fails */
#define SSH_ERROR 255

/* Server errors */
#define MODULE_ACTIVATION_ERR 1
#define CLIENT_CRED_ERR 11
#define SOCKET_CREATE_ERR 20
#define SOCKET_CONNECT_ERR 21
#define CLIENT_AUTH_FAILURE 30

#define DEFAULT_KEY_FILE ".globus/userkey.pem"
#define DEFAULT_CACHE_FILE ".gridssh.cache"


int initialize_conf(int argc, char **argv);
int finalize_conf(void);
void print_usage(void);

#endif
