/*
  
   Copyright 2004 Jonas Bardino

   This file is part of NorduGRID GridSSH.

    NorduGRID GridSSH is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    NorduGRID GridSSH is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with NorduGRID GridSSH; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

*/

#ifndef __RUNTIME_CONF_H__
#define __RUNTIME_CONF_H__

/* #include <limits.h> */

#define UNUSED -1

/* Changes in these strings should be reflected in sscanf of auth_client.c */
#define SUCCESS_STR "SUCCESS"
#define FAILED_STR "FAILED"

#define MAX_LIFETIME ULONG_MAX
#define NOT_AUTHORIZED -1

#define MAX_STATUS_LEN 128

/* Default sshd login gracetime is 120 s */
#define DEFAULT_LOGIN_TIMEOUT 120*1000000
#define DEFAULT_SSHD_PORT "22"
#define DEFAULT_GRIDSSHD_PORT "2222"

/* runtime configuration */
typedef struct runtime_config {
  char **argv;
  int argc;
  int max_procs;
  int log_stats;
  int use_cache;
  int debug_level;
  char *sshd_port;
  char *gridsshd_port;
  int address;
  int uid;
  int gid;
  int pid;
  char *pid_filename;
  char *prog;
  int ssh_mode;
  char *ssh_client;
  char *ssh_user;
  char *auth_filename;
  char *cache_filename;
  int expire_mode;
  /* can not use FILE * without including stdio :-( */
  void *out_file;
  void *err_file;
  int daemon_mode;
  int do_auth;
  int forward_proxy;
} runtime_conf;

runtime_conf *conf;

#endif
