#include <cstdlib>

#include "qapplication.h"
#include "qpixmap.h"
#include "MainWindow.h"

#if QT_VERSION >= 0x030200  // >= 3.2
#include "qsplashscreen.h"
#endif

int main( int argc, char** argv )
{
  QApplication app( argc, argv );

#if QT_VERSION >= 0x030200
  char* nordugrid_location = getenv( "NORDUGRID_LOCATION" );
  if( nordugrid_location==NULL ) nordugrid_location = DEFAULT_NORDUGRID_LOCATION;
  string splashpicture( nordugrid_location );
  splashpicture += "/share/splashpicture.png";

  QPixmap pixmap( splashpicture.c_str() );
  QSplashScreen* splash;
  if( !pixmap.isNull() ) {
    splash = new QSplashScreen( pixmap );
    splash->show();
    splash->message( "Fetching cluster-list" );
  }
#endif

  MainWindow theMainWindow( 0, "Main Window" );
  theMainWindow.resize( 720, 512 );
  app.setMainWidget( &theMainWindow );
  theMainWindow.show();

#if QT_VERSION >= 0x030200
  if( !pixmap.isNull() ) {
    splash->finish( &theMainWindow );
    delete splash;
  }
#endif

  return app.exec();
}
