#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <string>
#include <vector>

#ifndef UI_LDAPQUERY
#define UI_LDAPQUERY

typedef struct ldap LDAP;


class LdapQuery {

 public:
  LdapQuery ();
  ~LdapQuery () {};
  enum Scope { base, onelevel, subtree };
  int Connect (const string & ldaphost,
	       int ldapport,
	       const string & usersn,
	       bool anonymous,
	       int timeout,
	       int debug = 0);
  int Query (const string & base,
	     const string & filter,
	     const vector <string> & attributes,
	     Scope scope,
	     int timeout,
	     int debug = 0);
  int Result (void callback (const string & attr,
			     const string & value,
			     void * ref),
	      void * ref,
	      int timeout,
	      int debug = 0);
  int Find (const string & ldaphost,
	    int ldapport,
	    const string & usersn,
	    const string & base,
	    const string & filter,
	    const vector <string> & attributes,
	    Scope scope,
	    void callback (const string & attr,
			   const string & value,
			   void * ref),
	    void * ref,
	    bool anonymous,
	    int timeout,
	    int debug = 0);
 private:
  string host;
  int port;
  LDAP * connection;
  int messageid;
};

#endif
