/* ngjmlib.h - see ngjmlib.cpp for futher information */
/* Copyright 2003 Henrik Thostrup Jensen and Jesper Ryge Leth 
 * All rights reserved.
 *
 * This file is part of NGProxy.
 *	
 * NGProxy is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * NGProxy is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with NGProxy; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
/* ngjmlib.h contains functions that is used for pulling status
 * informations about jobs from the information system along with
 * some job id string manipulating functions.
 */
 
#ifndef JOBINFO_H
#define JOBINFO_H

/**
 * Returns a the cluster name from a job id string
 * a job id string should be on the form :
 * gsiftp://francis.auc.dk:2811/jobs/1725880770104498049
 */
string getClusterName(const string jobId);

/**
 * getJobStatus returns a string containing the status of job
 * given a job id. Job id should be of the same type as described
 * earlier in this file. The result will be something like :
 * "FAILED" , "FINISHED" , "DELETED" ...
 */
string getJobStatus(const string jobId);


Job* getJob(const string jobid);

/** 
 * Gets all the jobs corresponding to a vector of job ID's.
 * This is done on a per cluster basis, so there is only one query per cluster
 * rather than looking up each job individualy.
 */
vector<Job> getJobStatus(vector<string> jobIdList);

#endif // JOBINFO_H
